Subject: Re: [PATCH v2] Add Qualcomm Gobi 2000 driver.

From: Elly Jones <[email-masked]>
Date: Fri, 15 Oct 2010 09:17:28 -0400

On Fri, Oct 08, 2010 at 10:28:03AM -0700, David Miller wrote:
> From: Elly Jones <[email-masked]>
> Date: Wed, 6 Oct 2010 11:12:09 -0400
> 
> > From: Elizabeth Jones <[email-masked]>
> > 
> > This driver is a rewrite of the original Qualcomm GPL driver, released as part
> > of Qualcomm's "Code Aurora" initiative. The driver has been transformed into
> > Linux kernel style and made to use kernel APIs where appropriate; some bugs have
> > also been fixed. Note that the device in question requires firmware and a
> > firmware loader; the latter has been written by mjg (see
> > http://www.codon.org.uk/~mjg59/gobi_loader/).
> > 
> > Special thanks go to Joe Perches <[email-masked]> for major cleanup.
> > 
> > Signed-off-by: Elizabeth Jones <[email-masked]>
> > Signed-off-by: Jason Glasgow <[email-masked]>
> 
> I really think the firmware handling belongs in the kernel.
> 
> I've looked at the gobi_loader code and it's simpler than many
> of the gigabit ethernet driver firmware loader sequences in
> the tree already.
> 
> Requiring udev et al. magic only makes this networking device
> that much harder to use from an initrd.
> 
> I understand how this might be a bit clumsy since we'd need to make a
> dependency on the serial device since that is the mechanism by which
> the firmware is uploaded, but really I'd like you to consider it
> seriously.

Just to respond definitively to this: I believe the reasons mjg59 brought up are
valid and I will not try to put a firmware loader for this device in kernel
space. Additionally, Google could not in good conscience produce such a firmware
loader, as we have access to Qualcomm's closed-source firmware loader. Expect a
v3 of this patch shortly to address Joe Perches' concerns.

-- Elly